#include <vector>

bool v[10001][10001];
bool q[10001][10001];
int mm;

void generirai(){
    for(int i = 1; i <= mm; ++i){
        for(int j = 1; j <= mm; ++j){
            if(v[i][j] == 0) continue;
            else{
                for(int k = 0; k <= mm; ++k){
                    if(v[i][k] == 1 && k != j) {
                        q[j][k] = 1; q[k][j] = 1;
                    }
                }
            }
        }
    }
}

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{

    for(int i = 0; i < friendships.size(); ++i){
            v[friendships[i].first][friendships[i].second] = 1;
            v[friendships[i].second][friendships[i].first] = 1;
    }

    mm = N;
    generirai();
}

void connect(int ID, int x, int y)
{

    v[x][y] = 1;
    v[y][x] = 1;

    for(int i = 1; i <= mm; ++i){
        if(v[x][i] == 1 && i != y){
            q[y][i] = 1; q[i][y] = 1;
        }
        if(v[y][i] == 1 && i != x){
            q[i][x] = 1; q[x][i] = 1;
        }
    }

}

bool question(int ID, int x, int y)
{
    return q[y][x];
}

