#include <vector>

std::vector<std::vector<int>> adj;

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    adj.resize(N);
    const size_t size = friendships.size();
    for(int i = 0; i < size; i++)
        adj[friendships[i].first].push_back(friendships[i].second);
    return;
}

void connect(int ID, int x, int y)
{
    adj[x].push_back(y);
}

bool question(int ID, int x, int y)
{
    for(int i = 0; i < adj[x].size(); i++)
        for(int j = 0; j < adj[y].size(); j++)
            if(adj[x][i] == adj[y][j])
                return true;
    return false;
}