#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5+5;
const int MAXM = 1e5+5;

vector <int> G[MAXN];

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    for (int i = 0; i < M; i++)
    {
        int x = friendships[i].first;
        int y = friendships[i].second;
        G[x].push_back(y);
        G[y].push_back(x);
    }
}

void connect(int ID, int x, int y)
{
    G[x].push_back(y);
    G[y].push_back(x);
}

bool found;
int searchFor;

bool used[MAXN];

void dfs(int s, int br = 0)
{
    if (used[s] || found) return;
    used[s] = 1;
    cerr << s << " " << searchFor << " -- ";
    if (s == searchFor)
    {
        found = true;
        return;
    }
    if (br > 1) return;

    int sz = G[s].size();
    for (int i = 0; i < sz; i++)
        dfs(G[s][i], br+1);
}

bool question(int ID, int x, int y)
{
    memset(used, 0, sizeof(used));
    found = false;
    searchFor = y;

    dfs(x, 0);


    cerr << endl;
    return found;
}
