#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5+5;
const int MAXM = 1e5+5;

vector <int> G[MAXN];

set <int> fr[MAXN];

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    for (int i = 0; i < M; i++)
    {
        int x = friendships[i].first;
        int y = friendships[i].second;
        G[x].push_back(y);
        G[y].push_back(x);

        fr[x].insert(y);
        fr[y].insert(x);
    }
}

void connect(int ID, int x, int y)
{
    G[x].push_back(y);
    G[y].push_back(x);

    fr[x].insert(y);
    fr[y].insert(x);
}

bool found;
int searchFor;

bool used[MAXN];


bool question(int ID, int x, int y)
{
    memset(used, 0, sizeof(used));
    found = false;
    searchFor = y;

    int sz = G[x].size();

    for (int i = 0; i < sz; i++)
    {
        if (fr[G[x][i]].count(y))
            return true;
    }

    return false;
}
