#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5+5;
const int MAXM = 1e5+5;

vector <int> G[MAXN];

set <int> fr[MAXN];

set <pair<int,int>> commonFriend;

bool used[MAXN];

void dfs(int s, int prev = -1)
{
    if (used[s]) return;
    used[s] = 1;

    int sz = G[s].size();
    for (int i = 0; i < sz; i++)
    {
        int t = G[s][i];

        if (t == prev) continue;

        if (!commonFriend.count({t, prev}))
        {
            commonFriend.insert({t, prev});
            commonFriend.insert({prev, t});

        }


//        cerr << " = " << t << " " << prev << endl;

        dfs(t, s);
    }

    used[s] = 0;
}

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    for (int i = 0; i < M; i++)
    {
        int x = friendships[i].first;
        int y = friendships[i].second;
        G[x].push_back(y);
        G[y].push_back(x);

//        fr[x].insert(y);
//        fr[y].insert(x);
    }

    for (int i = 1; i <= N; i++)
        if (!used[i]) dfs(i);

}

void connect(int ID, int x, int y)
{
    G[x].push_back(y);
    G[y].push_back(x);

    fr[x].insert(y);
    fr[y].insert(x);
}

bool found;
int searchFor;


bool question(int ID, int x, int y)
{
    if (commonFriend.count({x, y}))
        return true;

    return false;
}
