#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5+5;
const int MAXM = 1e5+5;

vector <int> G[MAXN];

set <int> fr[MAXN];

set <pair<int,int>> commonFriend;

int used[MAXN];
bool visited[MAXN];

vector <int> v;

void dfs(int s, int prev = -1)
{
    if (used[s] == 3) return;

//    for (int i = 0; i < v.size(); i++)
//        cerr << v[i] << " ";
//    cerr << endl;

    for (int i = 2; i < v.size(); i++)
    {
        if (!commonFriend.count({v[i], v[i-2]}))
        {
            commonFriend.insert({v[i], v[i-2]});
            commonFriend.insert({v[i-2], v[i]});
        }
    }

//    if (s == prev) return;

    visited[s] = 1;

    int sz = G[s].size();
    for (int i = 0; i < sz; i++)
    {
        int t = G[s][i];

        if (t == prev)
        {
            if (!commonFriend.count({s, prev}) && commonFriend.count({t, prev}))
            {
                commonFriend.insert({s, prev});
                commonFriend.insert({prev, s});
            }
            continue;
        }

        if (!commonFriend.count({t, prev}))
        {
            commonFriend.insert({t, prev});
            commonFriend.insert({prev, t});
        }


//        cerr << " ***= " << t << " " << prev << endl;
        used[s]++;
        v.push_back(s);
        dfs(t, s);
        v.pop_back();
        used[s]--;
    }


}

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    for (int i = 0; i < M; i++)
    {
        int x = friendships[i].first;
        int y = friendships[i].second;
        G[x].push_back(y);
        G[y].push_back(x);

//        fr[x].insert(y);
//        fr[y].insert(x);
    }

    for (int i = 1; i <= N; i++)
        if (!visited[i]) dfs(i);

    for (auto i : commonFriend)
    {
        cout << " = " << i.first << " " << i.second << endl;
    }
}

void connect(int ID, int x, int y)
{
    G[x].push_back(y);
    G[y].push_back(x);

    fr[x].insert(y);
    fr[y].insert(x);
}

bool found;
int searchFor;


bool question(int ID, int x, int y)
{
    if (commonFriend.count({x, y}))
        return true;

    return false;
}
