#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5+5;
const int MAXM = 1e5+5;

vector <int> G[MAXN];

set <int> fr[MAXN];

set <pair<int,int>> commonFriend;

int used[MAXN];
bool visited[MAXN];

vector <int> v;

struct my
{
    int v, prev;
    my () {}
    my (int _v, int _prev)
    {
        v = _v;
        prev = _prev;
    }
};

void bfs(int s)
{
    queue <my> q;

    q.push(my(s, -1));

    double st = clock();

    while (!q.empty() && ((double)(clock() - st) / CLOCKS_PER_SEC) < 0.15)
    {
        int s = q.front().v;
        int prev = q.front().prev;

//        cerr << s << endl;

        q.pop();

        int sz = G[s].size();
        for (int i = 0; i < sz; i++)
        {
            if (!used[G[s][i]])
            {
                used[G[s][i]] = 1;

                if (!commonFriend.count({G[s][i], prev}))
                {
                    commonFriend.insert({G[s][i], prev});
                    commonFriend.insert({prev, G[s][i]});
                }

                q.push(my(G[s][i], s));

                used[G[s][i]] = 0;
            }
        }
    }
}

//void dfs(int s, int prev = -1)
//{
//    if (used[s] == 1) return;
//
////    for (int i = 0; i < v.size(); i++)
////        cerr << v[i] << " ";
////    cerr << endl;
//
//    for (int i = 2; i < v.size(); i++)
//    {
//        if (!commonFriend.count({v[i], v[i-2]}))
//        {
//            commonFriend.insert({v[i], v[i-2]});
//            commonFriend.insert({v[i-2], v[i]});
//        }
//    }
//
////    if (s == prev) return;
//
//    visited[s] = 1;
//
//    int sz = G[s].size();
//    for (int i = 0; i < sz; i++)
//    {
//        int t = G[s][i];
//
//        if (t == prev)
//        {
//            if (!commonFriend.count({s, prev}) && commonFriend.count({t, prev}))
//            {
//                commonFriend.insert({s, prev});
//                commonFriend.insert({prev, s});
//            }
//            continue;
//        }
//
//        if (!commonFriend.count({t, prev}))
//        {
//            commonFriend.insert({t, prev});
//            commonFriend.insert({prev, t});
//        }
//
//
////        cerr << " ***= " << t << " " << prev << endl;
//        used[s]++;
////        v.push_back(s);
//        bfs(t, s);
////        v.pop_back();
//        used[s]--;
//    }
//
//
//}

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    for (int i = 0; i < M; i++)
    {
        int x = friendships[i].first;
        int y = friendships[i].second;
        G[x].push_back(y);
        G[y].push_back(x);

//        fr[x].insert(y);
//        fr[y].insert(x);
    }

//    for (int i = 1; i <= min(N, 1); i++)
//        dfs(i);

    bfs(1);

    for (auto i : commonFriend)
    {
//        cout << " = " << i.first << " " << i.second << endl;
    }
}

void connect(int ID, int x, int y)
{
    G[x].push_back(y);
    G[y].push_back(x);

    fr[x].insert(y);
    fr[y].insert(x);
}

bool found;
int searchFor;


bool question(int ID, int x, int y)
{
    if (commonFriend.count({x, y}))
        return true;

    return false;
}
