
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 5e5+5;
int n, m;

vector <pair<int,int>> G[MAXN];

vector <vector<int>> paths;

vector <int> sol1(MAXN), sol2(MAXN);

vector <int> tmp;

//map <pair<int,int>> used;

int used[MAXN];

void dfs(int s)
{
//    int s = ss.first;
    if (used[s]) return;
//    used[s] = 1;

    if (s == n)
    {
//        for (int i = 0; i < tmp.size(); i++)
//            cerr << tmp[i] << " ";
//        cerr << endl;

//        if (sol1.size() > sol2.size())
//            swap(sol1, sol2);
//        if (tmp.size() < sol1.size())
//        {
//            swap(sol1, sol2);
//            sol1 = tmp;
//        }

        paths.push_back(tmp);

        return;
    }

    int sz = G[s].size();
    for (int i = 0; i < sz; i++)
    {
        tmp.push_back(G[s][i].second);
        used[s] = 1;
        dfs(G[s][i].first);
        used[s] = 0;
        tmp.pop_back();
    }
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        G[a].push_back({b, i+1});
    }

    dfs(1);

    int sz = paths.size();

    int minsum = 2e9;

    for (int i = 0; i < sz; i++)
    {
        for (int j = 0; j < sz; j++)
        {
            if (i == j) continue;

            bool flag = true;

            memset(used, 0, sizeof(used));

            for (int p = 0; p < paths[i].size(); p++)
            {
                used[paths[i][p]] = 1;
            }
            for (int p = 0; p < paths[j].size(); p++)
            {
                if (used[paths[j][p]])
                {
                    flag = false;
                }
            }

            if (flag)
            {
                if (paths[i].size() + paths[j].size() < minsum)
                {
                    minsum = paths[i].size() + paths[j].size();
                    sol1 = paths[i];
                    sol2 = paths[j];
                }
            }
        }
    }

    cout << sol1.size() << " " << sol2.size() << endl;
    for (int i = 0; i < sol1.size(); i++)
        cout << sol1[i] << " ";
    cout << endl;
    for (int i = 0; i < sol2.size(); i++)
        cout << sol2[i] << " ";
    cout << endl;

    return 0;
}
/**
12 18
1 2
1 3
2 4
3 5
3 6
4 5
4 9
5 3
5 8
6 7
7 8
7 7
8 12
8 12
9 10
10 11
11 8
11 9

*/

