
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 5e5+5;
int n, m;

vector <pair<int,int>> G[MAXN];
vector <int> sol1(MAXN), sol2(MAXN);

vector <int> tmp, tmp1;
int used[MAXN];

bool used2[MAXN];

bool used3[MAXN]; //indx

int minsum = 2e9;

void dfs1(int s)
{
    used2[s] = 1;

    if (tmp1.size() + tmp.size() > minsum) return;

    if (s == n)
    {
//        for (int i = 0; i < tmp.size(); i++)
//            cerr << tmp1[i] << " ";
//        cerr << endl;

        if (tmp.size() + tmp1.size() < minsum)
        {
            sol1 = tmp;
            sol2 = tmp1;
            minsum = tmp.size() + tmp1.size();
        }
        return;
    }

    int sz = G[s].size();

    for (int i = 0; i < sz; i++)
    {
        if (used3[G[s][i].second]) continue;
        tmp1.push_back(G[s][i].second);
        dfs1(G[s][i].first);
        tmp1.pop_back();
    }

}

void dfs(int s)
{
    if (used[s]) return;

    if (s == n)
    {
        dfs1(1);
        return;
    }

    int sz = G[s].size();

    for (int i = 0; i < sz; i++)
    {
        tmp.push_back(G[s][i].second);
        used3[G[s][i].second] = 1;
        used[s] = 1;
        dfs(G[s][i].first);
        tmp.pop_back();
        used[s] = 0;
        used3[G[s][i].second] = 0;
    }



}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        G[a].push_back({b, i+1});
    }

    dfs(1);

    cout << sol1.size() << " " << sol2.size() << endl;
    for (int i = 0; i < sol1.size(); i++)
        cout << sol1[i] << " ";
    cout << endl;
    for (int i = 0; i < sol2.size(); i++)
        cout << sol2[i] << " ";
    cout << endl;

    return 0;
}
/**
12 18
1 2
1 3
2 4
3 5
3 6
4 5
4 9
5 3
5 8
6 7
7 8
7 7
8 12
8 12
9 10
10 11
11 8
11 9

*/

