#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN=1e6+5;
const int INF=1e9;
int q;
int v;
vector<int> adj[MAXN];
int par[MAXN];
int tin[MAXN];
int depth[MAXN];
vector<pair<int,int> > qr;
int spt[MAXN][25];
void dfs(int curr)
{
    for(int i=0;i<adj[curr].size();i++)
    {
        depth[adj[curr][i]]=depth[curr]+1;
        dfs(adj[curr][i]);
    }
}

int maxd;
int lgMax;
void sparse_table()
{
    maxd=0;
    for(int i=1;i<=v;i++)
    {
        spt[i][0]=par[i];
        maxd=max(maxd,depth[i]);
    }
    int j;
    for(j=1;(1<<j)<maxd;j++)
    {
        for(int i=1;i<=v;i++)
        {
            spt[i][j]=spt[spt[i][j-1]][j-1];
        }
    }
    lgMax=j-1;
}

int find_anc(int cur,int t)
{
    int curLg=lgMax;
    for(;tin[par[cur]]<=t;)
    {
        while(curLg>=0 && tin[spt[cur][curLg]]>t) curLg--;
        if(curLg==-1) return cur;
        cur=spt[cur][curLg];
    }
    return cur;
}
int main()
{
ios::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);
cin>>q;
v=1;
for(int i=1;i<=q;i++)
{
    char c;
    cin>>c;
    if(c=='+')
    {
        int n;
        cin>>n;
        for(int j=0;j<n;j++)
        {
            int u;
            cin>>u;
            adj[v].push_back(u);
            par[u]=v;
        }
        par[v]=0; //
        tin[v]=i;
        v++;
    }
    else
    {
        int u;
        cin>>u;
        if(tin[u]==0) qr.push_back({0,0});
        else qr.push_back({u,i});
    }
}
v--;
tin[0]=INF;
depth[v]=1;
dfs(v);
sparse_table();
for(int i=0;i<qr.size();i++)
{
    if(qr[i].first==0)
    {
        cout<<0;
        continue;
    }
    int u=find_anc(qr[i].first,qr[i].second);
    if((depth[u]-depth[qr[i].first])%2==0) cout<<1;
    else cout<<0;
}
cout<<endl;
return 0;
}
