#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN=5e5+5;
const int INF=1e9;
struct edge
{
    int v,num;
    edge() {}
    edge(int _v,int _num)
    {
        v=_v;
        num=_num;
    }
};
int n,m;
vector<edge> adj[MAXN];
bool usedv1[MAXN];
bool usede[MAXN];
int usedv2[MAXN];
pair<int,int> edges[MAXN];
vector<int>v;
int ans1=INF;
int bfs(int s)
{
    memset(usedv2,0,sizeof(usedv2));
    queue<pair<int,int> > q;
    q.push({s,0});
    usedv2[s]=-1;
    int cur,d;
    while(!q.empty())
    {
        cur=q.front().first;
        d=q.front().second;
        q.pop();
        for(int i=0;i<adj[cur].size();i++)
        {
            if(!usedv2[adj[cur][i].v] && !usede[adj[cur][i].num])
            {
                if(adj[cur][i].v==n)
                {
                    v.clear();
                    v.push_back(adj[cur][i].num);
                    usede[adj[cur][i].num]=1;
                    while(cur!=1)
                    {
                        v.push_back(usedv2[cur]);
                        usede[usedv2[cur]]=1;
                        if(edges[usedv2[cur]].first!=cur) cur=edges[usedv2[cur]].first;
                        else cur=edges[usedv2[cur]].second;
                    }
                    return d+1;
                }
                usedv2[adj[cur][i].v]=adj[cur][i].num;
                q.push({adj[cur][i].v,d+1});
            }
        }
    }
    return -1;
}
int bfs2(int s)
{
    memset(usedv2,0,sizeof(usedv2));
    queue<pair<int,int> > q;
    q.push({s,0});
    usedv2[s]=-1;
    int cur,d;
    while(!q.empty())
    {
        cur=q.front().first;
        d=q.front().second;
        q.pop();
        for(int i=0;i<adj[cur].size();i++)
        {
            if(!usedv2[adj[cur][i].v] && !usede[adj[cur][i].num])
            {
                if(adj[cur][i].v==n)
                {
                    v.clear();
                    v.push_back(adj[cur][i].num);
                    while(cur!=1)
                    {
                        v.push_back(usedv2[cur]);
                        if(edges[usedv2[cur]].first!=cur) cur=edges[usedv2[cur]].first;
                        else cur=edges[usedv2[cur]].second;
                    }
                    return d+1;
                }
                usedv2[adj[cur][i].v]=adj[cur][i].num;
                q.push({adj[cur][i].v,d+1});
            }
        }
    }
    return -1;
}
vector<int> anss;
void dfs1(int cur,int d)
{
    if(cur==n)
    {
        int d2=bfs2(1);
        if(d2==-1) return;
        if(d+d2<ans1)
        {
            ans1=d+d2;
            anss.clear();
            for(int i=1;i<=m;i++)
            {
                if(usede[i]) anss.push_back(i);
            }
            anss.push_back(0);
            for(int i=v.size()-1;i>=0;i--)
            {
                anss.push_back(v[i]);
            }
        }
        return;
    }
    usedv1[cur]=1;
    for(int i=0;i<adj[cur].size();i++)
    {
        int next=adj[cur][i].v;
        if(!usedv1[next] && !usede[adj[cur][i].num])
        {
            usede[adj[cur][i].num]=1;
            dfs1(next,d+1);
            usede[adj[cur][i].num]=0;
        }
    }
    usedv1[cur]=0;
}
int main()
{
ios::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);
cin>>n>>m;
for(int i=1;i<=m;i++)
{
    int u,v;
    cin>>u>>v;
    adj[u].push_back(edge(v,i));
    adj[v].push_back(edge(u,i));
    edges[i].first=u;
    edges[i].second=v;
}
if(n<=10 && m<=10)
{
    dfs1(1,0);
    int br=0;
    for(int i=0;i<anss.size();i++)
    {
        if(anss[i]!=0) br++;
        else break;
    }
    cout<<br<<" "<<anss.size()-br-1<<endl;
    for(int i=0;i<anss.size();i++)
    {
        if(anss[i]!=0) cout<<anss[i]<<" ";
        else cout<<endl;
    }
    cout<<endl;
    return 0;
}
bfs(1);
cout<<v.size()<<" ";
anss=v;
bfs(1);
cout<<v.size()<<endl;
for(int i=anss.size()-1;i>=0;i--) cout<<anss[i]<<" "; cout<<endl;
//for(int i=v.size()-1;i>=0;i--) cout<<v[i]<<" "; cout<<endl;
for(int i=v.size()-1;i>=0;i--) cout<<v[i]<<" "; cout<<endl;
return 0;
}
