#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int maxn = (1<<20);

int q;
bitset<maxn> color;
int nodes = 0, input;
int questionLast[maxn], questionKey[maxn], questions = 0;
vector<int> children[maxn];
bitset<maxn> hasParent;

void init()
{
    hasParent.reset();
    cin >> q;
    char c;
    for(int i = 0; i < q; ++i)
    {
        cin >> c;
        if(c == '?')
        {
            questionLast[questions] = nodes;
            cin >> questionKey[questions];
            questions++;
        }
        else
        {
            nodes++;
            cin >> input;
            for(int j = input; j > 0; j--)
            {
                cin >> input;
                children[nodes].push_back(input);
                hasParent[input] = 1;
            }
        }
    }

    for(int i = 1; i <= nodes; i++) if(!hasParent[i]) children[0].push_back(i);
}

void build()
{
    int child;
    queue<int> bfs;
    bfs.push(0);
    while(bfs.size())
    {
        int top = bfs.front(); bfs.pop();
        for(int i = (children[top].size())-1; i >= 0; i--)
        {
            child = children[top][i];
            color[child] = !color[top];
            bfs.push(child);
        }
    }
}

void solve()
{
    for(int i = 0; i < questions; i++)
    {
        if(questionLast[i] == 0) cout << 1;
        else cout << (color[ questionLast[i] ] == color[ questionKey[i] ]);
    }
    cout << endl;
}

int main()
{
    init();
    build();
    solve();
    return 0;
}

/*

12
+ 0
+ 1 1
? 2
? 1
+ 0
? 1
+ 0
? 3
+ 3 3 2 4
? 4
? 2
? 1

*/
