#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int maxn = (1<<20);

int q;
bitset<maxn> color;
int nodes = 0, input;
vector<int> children[maxn];

void propagate(int node)
{
    int top, child;
    color[node] = 1;
    queue<int> bfs;
    bfs.push(node);
    while(bfs.size())
    {
        top = bfs.front(); bfs.pop();
        for(int i = children[top].size()-1; i >= 0; i--)
        {
            child = children[top][i];
            color[child] = !color[top];
            bfs.push(child);
        }
    }
}

void answer(int node)
{
    cout << color[node];
}

void solve()
{
    cin >> q; char c;
    for(int i = 0; i < q; i++)
    {
        cin >> c;
        if(c == '?')
        {
            cin >> input;
            answer(input);
        }
        else
        {
            nodes++;
            cin >> input;
            for(int j = input; j > 0; j--)
            {
                cin >> input;
                children[nodes].push_back(input);
            }
            propagate(nodes);
        }
    }
}


int main()
{
    solve();
    return 0;
}

/*

12
+ 0
+ 1 1
? 2
? 1
+ 0
? 1
+ 0
? 3
+ 3 3 2 4
? 4
? 2
? 1

*/
