#include<bits/stdc++.h>
#define endl '\n'
#define pi pair<int, int>
using namespace std;

const int maxn = 5e+5+5;
int n, m;
vector<pi> graph[maxn];
int f, t;
int parent[maxn];
int weight[maxn];

void solve()
{
    memset(parent, 0, sizeof(parent));
    memset(weight, 0, sizeof(weight));
    queue<int> q;
    q.push(1);

    while(q.size())
    {
        int top = q.front(); q.pop();
        for(int i = 0; i < (int)(graph[top].size()); i++)
        {
            int child = graph[top][i].first;
            if(weight[child] != 0) continue;
            weight[child] = weight[top] + 1;
            parent[child] = top;
            q.push(child);
            if(child == n) return;
        }
    }
}

void rebuild()
{
    int c = 1;
    vector<int> paths[2];
    int reb = n;
    while(reb != 0)
    {
        c = 1;
        for(int i = 0; i < graph[ parent[reb] ].size() && c > -1; i++)
        {
            if(graph[ parent[reb] ][i].first == reb)
            {
                paths[c--].push_back(graph[ parent[reb] ][i].second);
            }
        }
        reb = parent[reb];
    }
    cout << weight[n] << " " << weight[n] << endl;
    for(int i = weight[n]-1; i >= 0; i--)
    {
        cout << paths[1][i] << " ";
    }
    cout << endl;
    for(int i = weight[n]-1; i >= 0; i--)
    {
        cout << paths[0][i] << " ";
    }
    cout << endl;
}

int main()
{
    cin >> n >> m;
    for(int i = 1; i <= m; i++)
    {
        cin >> f >> t;
        graph[f].push_back({t, i});
    }
    solve();
    rebuild();
    return 0;
}
