#include <bits/stdc++.h>
using namespace std;

vector <int> components;

int compOf(int index)
{
    if(components[index]==index)
    {
        return index;
    }
    return components[index]=compOf(components[index]);
}

void conn(int x, int y)
{
    components[compOf(y)]=compOf(x);
}

bool connected(int x, int y)
{
    if(compOf(x)==compOf(y))
    {
        return true;
    }
    return false;
}

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    for(int i=0; i<=N; i++)
    {
        components.push_back(i);
    }
    for(int i=0; i<M; i++)
    {
        conn(friendships[i].first, friendships[i].second);
    }
}

void connect(int ID, int x, int y)
{
    conn(x, y);
}

bool question(int ID, int x, int y)
{
    return connected(x, y);
}
