#include <bits/stdc++.h>
using namespace std;
int id, n, m, q;
vector<vector<int>> user;


void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    id = ID;
    n = N;
    m = M;
    q = Q;
    user = vector<vector<int>>(n);
    for(auto i : friendships) {
        user.at(i.first - 1).push_back(i.second - 1);
        user.at(i.second - 1).push_back(i.first - 1);
    }
}

void connect(int ID, int x, int y)
{
    //printf("Adding friends: %d and %d", x, y);
    x--; y--;
    user.at(x).push_back(y);
    user.at(y).push_back(x);
}

bool question(int ID, int x, int y)
{
    x--; y--;
    int expected = user.at(x).size() + user.at(y).size();
    set<int> diff;
    for(const auto i : user.at(x)) {
        diff.insert(i);
    }
    for(const auto i : user.at(y)) {
        diff.insert(i);
    }
    if(diff.size() != expected) return true;
    return false;
}
