#include <bits/stdc++.h>
using namespace std;
struct Order;
vector<Order> orders;

struct Order {
    int id;
    vector<int> dependencies;
    vector<int> children;
    bool isActivated = true;
    Order(int _id) : id(_id){}
    void updateChildren() {
        for(auto i : children) {
            if(isActivated) {
                for(auto i : children) {
                    orders[i].isActivated = false;
                    orders[i].updateChildren();
                }
            }
            else {
                for(auto i : children) {
                    orders[i].isActivated = true;
                    orders[i].updateChildren();
                }
            }
        }
    }
};
int main() {
    int q;
    cin >> q;
    while(q--) {
        char command;
        cin >> command;
        if(command == '+') {
            orders.push_back(Order(orders.size() + 1));
            int n;
            cin >> n;
            while(n--) {
                int m;
                cin >> m;
                orders.at(orders.size() - 1).children.push_back(m - 1);
                orders.at(m - 1).dependencies.push_back(orders.size() - 1);
            }
            orders.at(orders.size() - 1).updateChildren();
        } else {
            int n;
            cin >> n;
            cout << orders.at(n - 1).isActivated;
        }
    }
}
