#include <bits/stdc++.h>
using namespace std;
struct Order;
vector<Order> orders;

struct Order {
    int id;
    vector<int> dependencies;
    Order(int _id) : id(_id){}
    bool isActivated() {
        for(auto i : dependencies) {
            if(orders[i].isActivated()) {
                return false;
            }
        }
        return true;
    }
};
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> q;
    while(q--) {
        char command;
        cin >> command;
        if(command == '+') {
            orders.push_back(Order(orders.size() + 1));
            int n;
            cin >> n;
            while(n--) {
                int m;
                cin >> m;
                orders.at(m - 1).dependencies.push_back(orders.size() - 1);
            }
        } else {
            int n;
            cin >> n;
            cout << orders.at(n - 1).isActivated();
        }
    }
}
