#include <vector>
#include<set>
using namespace std;
const int maxn=1e5+10;
set<int>v[maxn];
int n,m;
void initialize(int ID, int N, int M, int Q, vector < std::pair < int, int > > friendships)
{
    n=N;
    for(int i=0;i<M;++i)
    {
        v[friendships[i].first].insert(friendships[i].second);
        v[friendships[i].second].insert(friendships[i].first);
    }
}

void connect(int ID, int x, int y)
{
    v[x].insert(y);
    v[y].insert(x);
}

bool question(int ID, int x, int y)
{
    /*if(v[x].find(y)!=v[x].end())
        return true;*/
    int cur;
    for(auto it=v[x].begin();it!=v[x].end();++it)
    {
        cur=*it;
        if(v[cur].find(y)!=v[cur].end())
            return true;
    }
    return false;
}