#include <bits/stdc++.h>
using namespace std;
const int maxn=1e5+10;
struct seg_tree
{
    vector<int>arr,t;
    int sz;
    seg_tree(){sz=0;}
    seg_tree(int _sz)
    {
        sz=_sz;
        arr.resize(sz+1);
        arr.resize((sz+1)*4);
    }
    int query(int root,int l,int r,int ql,int qr)
    {
        if(l==ql&&r==qr)
            return t[root];
        int mid=(l+r)/2;
        if(qr<=mid)return query(root*2,l,mid,ql,qr);
        if(mid<ql)return query(root*2+1,mid+1,r,ql,qr);
        return query(root*2,l,mid,ql,mid)+query(root*2+1,mid+1,r,mid+1,qr);
    }
    int Query(int ql,int qr)
    {
        return query(1,1,sz,ql,qr);
    }
    void update(int root,int l,int r,int pos,int val)
    {
        if(l==r)
        {
            t[root]=val;
            return;
        }
        int mid=(l+r)/2;
        if(mid>=pos)update(root*2,l,mid,pos,val);
        else update(root*2+1,mid+1,r,pos,val);
        t[root]=t[root*2]+t[root*2+1];
    }
    void Update(int pos,int val,int ver)
    {
        arr[pos]=ver;
        update(pos,val,ver);
    }
};
//vector<seg_tree>T;
int n,m,chains_sz;
vector<int>v[maxn];
int chain[maxn],pos[maxn],lvl[maxn],subtree[maxn],lvl[maxn],head[maxn],parent[maxn];
set<int>st[maxn];
void DFS(int ver)
{
    int sz=v[ver].size(),mc=0,
    for(int i=0;i<sz;++i)
    {
        nb=v[ver];
        if(lvl[nb])continue;
        lvl[nb]=lvl[ver]+1;
        DFS(nb);
        parent[nb]=ver;
        subtree[ver]+=subtree[nb];
        if(subtree[nb]>mc)
        {
            mc=subtree[nb];
            heavy[ver]=nb;
        }
    }
    subtree[ver]++;
}
int HLD(int ver,int sz,int val)///val=1;
{
    pos[ver]=sz+1;
    if(sz)head[ver]=head[parent[ver]];
    else head[ver]=ver;
    int vsz=v[ver].size(),nb;
    for(int i=0;i<vsz;+i)
    {
        nb=v[ver][i];
        if(nb==parent[ver])continue;
        if(nb==heavy[ver])continue;
        else chain[nb]=HLD(nb,0,1);
    }
    if(heavy[ver]==-1)
    {
        chain[ver]=chains_sz;
        chains_sz++;
        //T.push_back(seg_tree(sz+1));
    }
    else chain[ver]=HLD(heavy[ver],sz+1,1);
    //T[chain[ver]].Update(pos[ver],val,ver);
    return chain[ver];
}

void init_large(vector < pair < int, int > > friendships)
{
    for(int i=0;i<m;++i)
    {
        v[friendships[i].first].push_back(friendships[i].second);
        v[friendships[i].second].push_back(friendships[i].first);
    }
    memset(heavy,-1,sizeof(heavy));
    lvl[1]=parent[1]=1;
    DFS(ver);
    HLD(1,0,0);

}
void initialize(int ID, int N, int M, int Q, vector < pair < int, int > > friendships)
{
    n=N;m=M;
    if(n>10000)init_large(friendships);
    else
    {
        for(int i=0;i<M;++i)
        {
            st[friendships[i].first].insert(friendships[i].second);
            st[friendships[i].second].insert(friendships[i].first);
        }
    }
}

void connect(int ID, int x, int y)
{
    st[x].insert(y);
    st[y].insert(x);
}
int Query_dist(int from,int to)
{
    int ans=0,a=from,b=to;
    while(head[a]!=head[b])
    {
        if(lvl[head[a]<lvl[head[b]])swap(a,b);
        ans+=pos[a];
        a=parent[head[a]];
    }
    if(pos[a]>pos[b])swap(a,b);
    ans+=(pos[b]-pos[a]-1);
    return ans;
}
int question_large(int x,int y)
{
    int ans=Query_dist(x,y);
    return (ans==1);
}
int question_small(int x,int y)
{
    int cur;
    for(auto it=v[x].begin();it!=v[x].end();++it)
    {
        cur=*it;
        if(v[cur].find(y)!=v[cur].end())
            return true;
    }
    return false;
}
bool question(int ID, int x, int y)
{
    if(n>10000)return question_large(x,y);
    else return question_small(x,y);
}
