#include<iostream>
#include <vector>

#include<fstream>

std::vector<std::vector<int>> adj;
std::vector<std::vector<int>> dp;

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    adj.resize(N+1);
    dp.resize(N+1, std::vector<int>(N+1));
    const size_t size = friendships.size();
    for(int i = 0; i < size; i++) {
        adj[friendships[i].first].push_back(friendships[i].second);
        adj[friendships[i].second].push_back(friendships[i].first);
    }
    return;
}

void connect(int ID, int x, int y)
{
    adj[x].push_back(y);
    adj[y].push_back(x);
}

bool question(int ID, int x, int y)
{
    //std::ofstream output("text1.txt");

    for(int i = 0; i < adj[x].size(); i++)
        for(int j = 0; j < adj[y].size(); j++) {
            //std::cout << x << "s friend: " << adj[x][i] << " " << y << "s friend: " << adj[y][j] << std::endl;
            if(adj[x][i] == adj[y][j]) {
                return true;
            }
        }
    //output << "razbiram da\n";
    return false;
}

/* int main() {
    initialize(0, 3, 2, 1, {{1,2}, {2,3}});
    std::cout << "hello\n";
} *