#include<iostream>
#include<vector>

#include<unordered_set>

int main() {
    int Q;
    std::cin >> Q;

    std::vector<std::pair<std::unordered_set<int>, std::vector<int>>> ban(10001);
    int order = 1;

    while(Q--) {
        char sign;
        std::cin >> sign;

        if(sign == '+') {
            int size;
            std::cin >> size;

            for(int i = 0; i < size; i++) {
                int key;
                std::cin >> key;

                ban[key].first.insert(order);
                ban[order].second.push_back(key);

                for(int j = 0 ; j < ban.size(); j++) {
                    if(ban[j].first.find(key) != ban[j].first.end()) {
                        ban[j].first.erase(key);

                        if(ban[j].first.size() == 0) {
                            for(int k = 0; k < ban[j].second.size(); k++) {
                                ban[ban[j].second[k]].first.insert(j);
                            }
                        }
                    }
                }
            }
            order++;
        } else if(sign == '?') {
            int key;
            std::cin >> key;
            
            if(ban[key].first.size() == 0)
                std::cout << "1";
            else
                std::cout << "0";
        }
    }
    std::cout << std::endl;
}