#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5+5;
const int MAXM = 1e5+5;

vector <int> G[MAXN];

set <int> fr[MAXN];

set <pair<int,int>> commonFriend;

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    for (int i = 0; i < M; i++)
    {
        int x = friendships[i].first;
        int y = friendships[i].second;
        G[x].push_back(y);
        G[y].push_back(x);

//        fr[x].insert(y);
//        fr[y].insert(x);
    }

    int cont = 0;

    for (int i = 1; i <= N; i++)
    {
        int sz = G[i].size();
//        cerr << i << endl;
        for (int j = 0; j < sz; j++)
        {
            int ind = G[i][j];
            if (ind == i) continue;
//            cerr << i << " "  << j << endl;
            int sz2 = G[ind].size();
//            cerr << "ssz: " << sz2 << endl;
            for (int k = 0; k < sz2; k++)
            {
                commonFriend.insert({i, G[ind][k]});
                commonFriend.insert({G[ind][k], i});
//                cerr << "= " << i << " " << G[ind][k] << endl;
                cont++;
            }
        }
    }
//    cerr << "Cont: " << cont << endl;
}

void connect(int ID, int x, int y)
{
    G[x].push_back(y);
    G[y].push_back(x);

    fr[x].insert(y);
    fr[y].insert(x);
}

bool found;
int searchFor;

bool used[MAXN];


bool question(int ID, int x, int y)
{
    memset(used, 0, sizeof(used));
    found = false;
    searchFor = y;

    if (commonFriend.count({x, y}))
        return true;

    if (ID >= 4) return false;

    int sz = G[x].size();

    for (int i = 0; i < sz; i++)
    {
        if (fr[G[x][i]].count(y))
            return true;
    }

    return false;
}
