#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXQ = 1e6+6;

vector <int> G[MAXQ];
bool active[MAXQ];

bool used[MAXQ];

void dfs(int s)
{
    if (used[s]) return;
    used[s] = 1;

    int sz = G[s].size();
    for (int i = 0; i < sz; i++)
    {
        active[G[s][i]] = !(active[G[s][i]]);
        dfs(G[s][i]);
    }
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int q;
    cin >> q;

    int br = 0;

    for (int i = 1; i <= q; i++)
    {
        char c;
        cin >> c;
        if (c == '+')
        {
            br++;
            active[br] = true;
            int n = 0;
            cin >> n;

            for (int j = 0; j < n; j++)
            {
                int p;
                cin >> p;

                G[i].push_back(p);
                active[p] = false;

                memset(used, 0, sizeof(used));

                dfs(p);
            }
//
//            for (int j = 1; j <= q; j++)
//                cerr << active[j];
//            cerr << endl;
        }
        else
        {
            int p;
            cin >> p;
            cout << active[p];
        }
    }
    cout << endl;

    return 0;
}
/**
12
+ 0
+ 1 1
? 2
? 1
+ 0
? 1
+ 0
? 3
+ 3 3 2 4
? 4
? 2
? 1


4
+ 0
+ 1 1
+ 1 2
+ 1 3

*/

