#include <bits/stdc++.h>
using namespace std;

vector <int> nbs[100003];
int comp[100003], level[100003], parent[100003], broi[100003], c, nomer[100003], k;
bool used[100003];

void dfs (int curr) {
    k++;
    nomer[curr] = k;
    used[curr] = true;
    if (nbs[curr].size() == 1 and parent[curr] != -1) {
        broi[curr] = 1;
        return;
    }
    for (int i=0; i < nbs[curr].size(); i++) {
        int currn = nbs[curr][i];
        if (currn == parent[curr] or used[currn] == true) {continue;}
        comp[currn] = comp[curr];
        level[currn] = level[curr] + 1;
        parent[currn] = curr;
        dfs (currn);
        broi[curr] += broi[currn];
    }
    broi[curr]+=1;
}

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    for (int i=0; i < friendships.size(); i++) {
        int x = friendships[i].first, y = friendships[i].second;
        nbs[x].push_back(y);
        nbs[y].push_back(x);
    }
    for (int i=1; i <= N; i++) {
        if (used[i] == true) {continue;}
        c++;
        comp[i] = c;
        parent[i] = -1;
        level[i] = 1;
        k=0;
        dfs (i);
    }
    for (int i=1; i <= N; i++) {
        cout << i << ": ";
        cout << comp[i] << " " << nomer[i] << " " << parent[i] << " " << broi[i] << " " << level[i] << endl;
    }
}

void connect(int ID, int x, int y)
{
    nbs[x].push_back(y);
    nbs[y].push_back(x);
}

bool question(int ID, int x, int y)
{
    if (comp[x] != comp[y]) {return false;}
    if (parent[x] == parent[y]) {return true;}
    if (level[x] < level[y]) {swap (x, y);}
    if (level[x] - level[y] == 2 and nomer[x] > nomer[y] and nomer[x] < broi[y] + nomer[y]) {return true;}
    return false;
}
