#include <iostream>
#include <vector>
#include <queue>
#include <stack>
using namespace std;
const int MAXN=5e5+10;
vector <pair <int,int> > v[MAXN];
queue <int> q;
int dist[MAXN];
pair <int,int> pr[MAXN];
stack <int> st1, st2;
bool used[MAXN];
void bfs(int ind) {
    dist[1]=0;
    q.push(1);
    pr[1]={-1,-1};
    while (!q.empty()) {
        int x=q.front();
        q.pop();
        for (auto i:v[x]) {
            if (used[i.second]) continue;
            if (dist[i.first]==-1) {
                dist[i.first]=dist[x]+1;
                pr[i.first]={x,i.second};
                q.push(i.first);
            }
        }
    }
}
int main () {
    /**
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);**/
    int n, m, a, b;
    cin >> n >> m;
    for (int i=1;i<=m;i++) {
        cin >> a >> b;
        v[a].push_back({b,i});
    }
    for (int i=1;i<=n;i++) dist[i]=-1;
    bfs(0);
    int cur=n;
    while (cur!=1) {
        st1.push(pr[cur].second);
        used[st1.top()]=true;
        cur=pr[cur].first;
    }
    for (int i=1;i<=n;i++) dist[i]=-1;
    bfs(1);
    cur=n;
    while (cur!=1) {
        st2.push(pr[cur].second);
        cur=pr[cur].first;
    }
    cout << st1.size() << ' ' << st2.size() << endl;
    while (!st1.empty()) {
        cout << st1.top() << ' ';
        st1.pop();
    }
    cout << endl;
    while (!st2.empty()) {
        cout << st2.top() << ' ';
        st2.pop();
    }
    cout << endl;
    return 0;
}
/**

12 19
1 6
6 7
1 8
8 1
1 2
8 9
9 11
11 2
11 10
10 3
1 2
2 3
3 4
2 3
4 12
3 4
4 12
7 5
5 2
**/
