#include <bits/stdc++.h>
using namespace std;
int id, n, m, q;
vector<vector<int>> user;
vector<vector<int>> aquainted;

void addLink(int x, int y, bool isUser) {
    if(isUser) {
        user.at(x).push_back(y);
        user.at(y).push_back(x);
    } else {
        aquainted.at(x).push_back(y);
        aquainted.at(y).push_back(x);
    }
}

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    id = ID;
    n = N;
    m = M;
    q = Q;
    user = vector<vector<int>>(n);
    aquainted = vector<vector<int>>(n);
    for(auto i : friendships) {
        addLink(i.first - 1, i.second - 1, true);
        for(auto j : user.at(i.first - 1)) {
            addLink(i.second - 1, j, false);
        }
        for(auto j : user.at(i.second - 1)) {
            addLink(i.first - 1, j, false);
        }
    }
}

void connect(int ID, int x, int y)
{
    x--; y--;
    addLink(x, y, true);
    for(auto j : user.at(x)) {
        addLink(y, j, false);
    }
    for(auto j : user.at(y)) {
        addLink(x, j, false);
    }
}

bool question(int ID, int x, int y)
{
    x--; y--;
    if(find(aquainted.at(x).begin(), aquainted.at(x).end(), y) != aquainted.at(x).end()) return true;
    return false;
}
