#include <bits/stdc++.h>
#define MAX (int)1e5
using namespace std;
int id, n, m, q;
vector<vector<int>> user;
vector<vector<bool>> matrix;

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    id = ID;
    n = N;
    m = M;
    q = Q;
    matrix = vector<vector<bool>>(n);
    for(int i = 0; i < n; i++) {
        matrix[i] = vector<bool>(n);
        for(int j = 0; j < n; j++) {
            matrix[i][j] = false;
        }
    }
    user = vector<vector<int>>(n);
    for(auto i : friendships) {
        user.at(i.first - 1).push_back(i.second - 1);
        matrix[i.first - 1][i.second - 1] = true;
        user.at(i.second - 1).push_back(i.first - 1);
        matrix[i.second - 1][i.first - 1] = true;
    }
}

void connect(int ID, int x, int y)
{
    //printf("Adding friends: %d and %d", x, y);
    x--; y--;
    user.at(x).push_back(y);
    matrix[x][y] = true;
    user.at(y).push_back(x);
    matrix[y][x] = true;
}

bool question(int ID, int x, int y)
{
    x--; y--;
    for(auto i : user.at(x)) {
        if(matrix[y][i]) return true;
    }
    return false;
}
