#include<bits/stdc++.h>
using namespace std;

const int maxn=500003;
int n, m;
vector< pair<int, int> > nbrs[maxn], nbrs1[maxn];
bool used_p[maxn], used_n[maxn], moje_li[maxn];
int dist[maxn];

vector<int> p, q;

bool moje(int x){
    queue<int> q;
    used_n[1]=true;
    q.push(1);
    dist[1]=0;

    while(!q.empty()){
        int curr=q.front();
        q.pop();

        for(int i=0; i<nbrs[curr].size(); i++){
            int path=nbrs[curr][i].second;
            int node=nbrs[curr][i].first;
            if( !used_p[path] and dist[node]==0 and moje_li[path]){
                used_p[path]=true;
                dist[node]=dist[curr]+1;
                //cerr<<"dist to "<<node<<" = "<<dist[node]<<endl;
                if(node==n){
                    if(dist[n]>x){
                        return false;
                    }
                    return true;
                }
                q.push(node);
            }
        }
    }
}

void find_r(int x){
    int curr=dist[x];
    if(x==1){
        return ;
    }

    for(int i=0; i<nbrs1[x].size(); i++){
        int path=nbrs1[x][i].second;
        int node=nbrs1[x][i].first;
        if(dist[node]==curr-1){
            //cerr<<"ot "<<x<<" na "<<node<<endl;
            moje_li[path]=false;
            p.push_back(path);
            find_r(node);
            break;
        }
    }

    return ;
}

void find_r1(int x){
    int curr=dist[x];
    if(x==1){
        return ;
    }

    for(int i=0; i<nbrs1[x].size(); i++){
        int path=nbrs1[x][i].second;
        int node=nbrs1[x][i].first;
        if(dist[node]==curr-1){
            //cerr<<"ot "<<x<<" na "<<node<<endl;
            moje_li[path]=false;
            q.push_back(path);
            find_r(node);
            break;
        }
    }

    return ;
}

int main(){
ios_base::sync_with_stdio(false);
cin.tie(NULL);

cin>>n>>m;

for(int i=0; i<m; i++){
    int a, b;
    moje_li[i]=true;
    cin>>a>>b;
    nbrs[a].push_back({b, i});
    nbrs1[b].push_back({a, i});
}
int l=1, r=n+1;
while(l!=r-1){
    int mid=(l+r)/2;
    for(int i=0; i<=n; i++){
        dist[i]=0;
        used_n[i]=false;
    }
    for(int i=0; i<=m; i++){
        used_p[i]=false;
    }
    if(moje(mid)){
        //cerr<<"s "<<mid<<" stava"<<endl;

        r=mid;
    }else{
        l=mid;
    }
}
find_r(n);


l=1, r=n+1;
while(l!=r-1){
    int mid=(l+r)/2;
    for(int i=0; i<=n; i++){
        dist[i]=0;
        used_n[i]=false;
    }
    for(int i=0; i<=m; i++){
        if(moje_li[i]){
            used_p[i]=false;
        }
    }
    if(moje(mid)){
        //cerr<<"s "<<mid<<" stava"<<endl;

        r=mid;
    }else{
        l=mid;
    }
}
find_r1(n);


cout<<p.size()<<endl;
cout<<q.size()<<endl;
for(int i=p.size()-1; i>=0; i--){
    cout<<p[i]+1<<" ";
}
cout<<endl;

for(int i=q.size()-1; i>=0; i--){
    cout<<q[i]+1<<" ";
}
cout<<endl;
return 0;
}
