#include <vector>
#include<set>
using namespace std;
const int maxn=1e5+10;
int n,start_ver,used[maxn];
vector<int>v[maxn];
set<pair<int,int> >knowns;
void DFS(int ver,int depth)
{
    if(depth==2)
    {
        pair<int,int>help;
        help.first=min(ver,start_ver);
        help.second=max(ver,start_ver);
        knowns.insert(help);
        return;
    }
    //used[nb]=1;
    int sz=v[ver].size(),nb;
    for(int i=0;i<sz;++i)
    {
        nb=v[ver][i];
        if(nb==start_ver)continue;
        DFS(v[ver][i],depth+1);
    }
}
void initialize(int ID, int N, int M, int Q, vector < std::pair < int, int > > friendships)
{
    n=N;
    for(int i=0;i<M;++i)
    {
        v[friendships[i].first].push_back(friendships[i].second);
        v[friendships[i].second].push_back(friendships[i].first);
    }
    for(int i=1;i<=n;++i)
    {
        start_ver=i;
        DFS(start_ver,0);
        //memset(used,0,sizeof(useed));
    }
}

void connect(int ID, int x, int y)
{
    v[x].push_back(y);
    v[y].push_back(x);
    start_ver=x;
    DFS(x,0);
    start_ver=y;
    DFS(y,0);
}

bool question(int ID, int x, int y)
{
    pair<int,int>help={min(x,y),max(x,y)};
    return (knowns.find(help)!=knowns.end());
}
/*
1
8 9 9
5 8
3 1
4 8
7 5
6 2
4 3
2 3
6 1
3 8
? 6 2
+ 1 2
? 6 2
? 5 4
? 6 4
+ 8 6
? 6 4
? 4 8
? 5 2
*/
